## Contributing

ipaddress welcomes contributions and appreciates contributions from the community. Please follow the code below.

### Issues

We welcome you to submit any issues or enhancement requests. When doing so, please provide minimal reproducible examples, 
as source code is often more effective in helping others understand the issue. If you encounter crash problems on specific 
platforms, please include operating system and compiler information.

### Pull Requests

We welcome pull requests for fixes and features. To avoid any unnecessary time investment, we strongly recommend opening an issue to discuss whether the proposed PR aligns with our guidelines.

To do this, follow these steps:

1. **Fork** the repository on GitHub.
2. **Clone** the project to your local machine and create a new branch within your fork. Start your development work on this branch.
3. **Test** your changes. If possible, include unit tests for IPv4 addresses, IPv6 addresses, IP addresses, IPv4 networks, IPv6 networks, or IP networks, depending on the modifications you’ve made.
4. **Commit** your changes to your branch.
5. **Push** your work back to your fork on GitHub.
6. Finally, **submit a pull request** so that we can review your changes.

NOTE: Be sure to merge the latest from "upstream" before making a pull request!

Currently, I am the sole maintainer of this project. Therefore, I will monitor questions, suggestions, as well as community activity and interest in this project to the best of my abilities.
